require('lang.load')
import('application.Interface')
import('model.GuiEvent')
import('model.Cursor')
import('model.toolbar.section.table.Inventory')
import('model.events.CursorStackChanged')
import('model.events.InventoryChanged')

---@param eventData EventData
script.on_event("interface-mod_create-toolbar", function(eventData)
    --Interface:new(eventData.player_index):deleteAll()
    Interface:new(eventData.player_index):createToolbar()
end)

---@param eventData EventData
script.on_event(defines.events.on_gui_click, function(eventData)
    Interface:new(eventData.player_index):handleGuiEvent(GuiEvent:new(eventData))
end)

---@param eventData EventData
script.on_event(defines.events.on_gui_elem_changed, function(eventData)
    Interface:new(eventData.player_index):handleGuiEvent(GuiEvent:new(eventData))
end)

---@param eventData EventData
script.on_event(defines.events.on_gui_location_changed, function(eventData)
    Interface:new(eventData.player_index):handleGuiEvent(GuiEvent:new(eventData))
end)

---@param eventData EventData
script.on_event(defines.events.on_player_cursor_stack_changed, function(eventData)
    Interface:new(eventData.player_index):handle(CursorStackChanged:new(eventData))
end)

---@param eventData EventData
script.on_event(defines.events.on_player_main_inventory_changed, function(eventData)
    Interface:new(eventData.player_index):handle(InventoryChanged:new(eventData))
end)

---@param eventData EventData
script.on_event(defines.events.on_player_trash_inventory_changed, function(eventData)
    Interface:new(eventData.player_index):handle(InventoryChanged:new(eventData))
end)

-- seems that defines.events.on_player_changed_surface is triggered before new inventory is available
---@param eventData EventData
script.on_event(defines.events.on_player_toggled_map_editor, function(eventData)
    Interface:new(eventData.player_index):handle(InventoryChanged:new(eventData))
end)

remote.add_interface("interface-mod", {
    updateCount = function(player_index)
        for _ = 0, 100 do
            Interface:new(player_index):handle(InventoryChanged:new({}))
        end
    end
})
