import('model.Event')

---@class GuiEvent : Event
---@field _eventData EventData
GuiEvent = Event:extendAs("model.GuiEvent")

---@param eventData EventData
function GuiEvent:new(eventData)
    return GuiEvent:super(Event:new(eventData))
end

---@public
---@return string
function Event:modName()
    return self:element().get_mod()
end

---@return LuaGuiElement
function GuiEvent:element()
    return self:data().element
end

---@public
---@return boolean
function GuiEvent:isLeftClick()
    return self:isClick() and self:data().button ==  defines.mouse_button_type.left
end

---@public
---@return boolean
function GuiEvent:isMiddleClick()
    return self:isClick() and self:data().button ==  defines.mouse_button_type.middle
end

---@public
---@return boolean
function GuiEvent:isRightClick()
    return self:isClick() and self:data().button ==  defines.mouse_button_type.right
end

---@public
---@return boolean
function GuiEvent:isClick()
    return self:data().name == defines.events.on_gui_click
end

---@public
---@return boolean
function GuiEvent:isElementChange()
    return self:data().name == defines.events.on_gui_elem_changed
end

---@public
---@return boolean
function GuiEvent:isLocationChange()
    return self:data().name == defines.events.on_gui_location_changed
end
