import('model.Component')

---@class Screen : Component
Screen = Component:extendAs("model.Screen")

---@param player LuaPlayer
function Screen:new(player)
    return Screen:super(Component:new(player.gui.screen))
end

function Screen:childrenClasses()
    return { Toolbar }
end

---@public
---@return Toolbar
function Screen:createToolbar()
    return Toolbar:create(self:root())
end


---@private
---@param element LuaGuiElement
---@return boolean
function Screen:is(element)
    return element.gui.screen == element
end
