import('model.Component')
import('model.toolbar.Toolbar')

---@class AddSection : Component
AddSection = Component:extendAs("model.toolbar.AddSection")

function AddSection:create(parent)
    local root = AddSection:createRoot(parent, {
        type = "button",
        sprite = "interface-mod_add-section",
        style = "toolbar_content_addSection" })
    root.caption = "Add section"
    return AddSection:new(root)
end

function AddSection:new(element)
    return AddSection:super(Component:new(element))
end

function AddSection:handleGuiEvent(guiEvent)
    if guiEvent:isLeftClick() then
        self:ancestor(Toolbar):addSection()
    end
end

function AddSection:lock()
    self:hide()
end

function AddSection:unlock()
    self:show()
end
