import('model.Component')
import('model.toolbar.section.Section')

---@class SectionList : Component
SectionList = Slot:extendAs("model.toolbar.SectionsList")

function SectionList:create(parent)
    local root = SectionList:createRoot(parent, {
        type = "flow",
        direction = "vertical",
        style = "toolbar_content_sectionList" })
    local list = SectionList:new(root)
    list:addSection()
    return list
end

---@public
---@return SectionList
---@param element LuaGuiElement
function SectionList:new(element)
    return SectionList:super(Component:new(element))
end

function SectionList:childrenClasses()
    return { Section }
end

---@public
function SectionList:addSection()
    Section:create(self:root())
end

---@public
---@return number
function SectionList:count()
    return #self:root().children
end

---@public
---@return Section[]
function SectionList:sections()
    return self:children(Section)
end
