import('model.Component')
import('model.toolbar.SectionList')
import('model.toolbar.AddSection')

---@class ToolbarContent : Component
ToolbarContent = Slot:extendAs("model.toolbar.Content")

function ToolbarContent:create(parent)
    local root = ToolbarContent:createRoot(parent, {
        type = "flow",
        direction = "vertical",
        style = "toolbar_content" })
    SectionList:create(root)
    AddSection:create(root)
    return ToolbarContent:new(root)
end

---@public
---@return ToolbarContent
---@param element LuaGuiElement
function ToolbarContent:new(element)
    return ToolbarContent:super(Component:new(element))
end

function ToolbarContent:childrenClasses()
    return { SectionList, AddSection }
end

---@public
---@return SectionList
function ToolbarContent:sectionList()
    return self:child(SectionList)
end
