import('model.toolbar.header.ToolbarHeaderButton')

---@class CollapseToolbar : ToolbarHeaderButton
CollapseToolbar = ToolbarHeaderButton:extendAs("model.toolbar.header.Collapse")

function CollapseToolbar:create(parent)
    local root = CollapseToolbar:createRoot(parent, {
        type = "sprite-button",
        sprite = "interface-mod_collapse",
        style = "toolbar_button_icon_black" })
    return CollapseToolbar:new(root)
end

function CollapseToolbar:new(element)
    return CollapseToolbar:super(ToolbarHeaderButton:new(element))
end

function CollapseToolbar:handleGuiEvent(guiEvent)
    if guiEvent:isLeftClick() then
        self:toolbar():collapse()
    end
    local expand = ExpandToolbar:create(self:parent())
    if self:isLocked() then expand:lock() end
    self:replaceWith(expand)
end
