import('model.toolbar.header.ToolbarHeaderButton')
import('model.toolbar.header.CollapseToolbar')

---@class ExpandToolbar : ToolbarHeaderButton
ExpandToolbar = ToolbarHeaderButton:extendAs("model.toolbar.header.Expand")

function ExpandToolbar:create(parent)
    local root = ExpandToolbar:createRoot(parent, {
        type = "sprite-button",
        sprite = "interface-mod_expand",
        style = "toolbar_button_icon_black" })
    return ExpandToolbar:new(root)
end

function ExpandToolbar:new(element)
    return ExpandToolbar:super(ToolbarHeaderButton:new(element))
end

function ExpandToolbar:handleGuiEvent(guiEvent)
    if guiEvent:isLeftClick() then
        self:toolbar():expand()
    end
    local collapse = CollapseToolbar:create(self:parent())
    if self:isLocked() then collapse:lock() end
    self:replaceWith(collapse)
end
