import('model.Component')
import('model.toolbar.Toolbar')
import('model.toolbar.header.ToolbarHeader')

---@class ToolbarHeaderButton : Component
ToolbarHeaderButton = Component:extendAs("model.toolbar.header.Button")

function ToolbarHeaderButton:new(root)
    return ToolbarHeaderButton:super(Component:new(root))
end

---@protected
---@return Toolbar
function ToolbarHeaderButton:toolbar()
    return self:ancestor(Toolbar)
end

---@protected
---@return ToolbarHeader
function ToolbarHeaderButton:header()
    return self:ancestor(ToolbarHeader)
end

function ToolbarHeaderButton:lock()
    self:root().style.size = 16
end

function ToolbarHeaderButton:unlock()
    self:root().style.size = 20
end

---@protected
---@return boolean
function ToolbarHeaderButton:isLocked()
    return self:root().style.maximal_width == 16
end
