import('model.toolbar.header.ToolbarHeaderButton')
import('model.toolbar.header.Lock')

---@class Unlock : ToolbarHeaderButton
Unlock = ToolbarHeaderButton:extendAs("model.toolbar.header.Unlock")

function Unlock:create(parent)
    local root = Unlock:createRoot(parent, {
        type = "sprite-button",
        sprite = "interface-mod_padlock-closed",
        style = "toolbar_button_icon_black" })
    local unlock = Unlock:new(root)
    unlock:lock()
    return unlock
end

function Unlock:new(element)
    return Unlock:super(ToolbarHeaderButton:new(element))
end

function Unlock:handleGuiEvent(guiEvent)
    if guiEvent:isLeftClick() then
        self:toolbar():unlock()
    end
end

function Unlock:unlock()
    self:replaceWith(Lock:create(self:parent()))
end
