import('model.Component')
import('model.toolbar.section.SectionContent')
import('model.toolbar.section.header.SectionHeader')
import('model.toolbar.section.table.Table')

---@class Section : Component
Section = Component:extendAs("model.toolbar.section.Section")

function Section:create(parent)
    local root = Section:createRoot(parent, {
    type = "frame",
    direction = "vertical",
    style = "toolbar_content_sectionList_section" })
    SectionHeader:create(root)
    SectionContent:create(root)
    return Section:new(root)
end

function Section:new(element)
    return Section:super(Component:new(element))
end

function Section:childrenClasses()
    return { SectionHeader, SectionContent }
end

function Section:moveDown()
    if #self:siblingsAndMe() > self:index() then
        self:parent().swap_children(self:index(), self:index() + 1)
    end
end

function Section:moveUp()
    if self:index() > 1 then
        self:parent().swap_children(self:index(), self:index() - 1)
    end
end

function Section:collapse()
    self:content():hide()
end

function Section:expand()
    self:content():show()
end

function Section:content()
    return self:child(SectionContent)
end
