import('model.Component')
import('model.toolbar.section.table.Table')

---@class SectionContent : Component
SectionContent = Slot:extendAs("model.toolbar.section.Content")

function SectionContent:create(parent)
    local root = SectionContent:createRoot(parent, {
        type = "flow",
        direction = "vertical" })
    Table:create(root)
    return SectionContent:new(root)
end

---@public
---@return SectionContent
---@param element LuaGuiElement
function SectionContent:new(element)
    return SectionContent:super(Component:new(element))
end

function SectionContent:childrenClasses()
    return { Table }
end

---@public
---@return Table
function SectionContent:table()
    return self:child(Table)
end
