import('model.toolbar.section.header.SectionHeaderButton')

---@class DeleteSection : SectionHeaderButton
DeleteSection = SectionHeaderButton:extendAs("model.toolbar.section.header.Delete")

function DeleteSection:create(parent)
    local root = DeleteSection:createRoot(parent, {
        type = "sprite-button",
        sprite = "utility/trash",
        style = "toolbar_button_icon_red" })
    return DeleteSection:new(root)
end

function DeleteSection:new(element)
    return DeleteSection:super(SectionHeaderButton:new(element))
end

function DeleteSection:handleGuiEvent(guiEvent)
    if guiEvent:isLeftClick() then
        self:header():askForDeletion()
    end
end

function DeleteSection:lock()
    self:hide()
end

function DeleteSection:unlock()
    self:show()
end
