import('lang.Object')

---@class History : Object
---@field private _pickedSlot Slot
History = Object:extendAs("model.toolbar.section.table.History")

---@param player_index number
function History:getInstanceFor(player_index)
    if History.__perPlayer == nil then
        History.__perPlayer = {}
    end
    if not History.__perPlayer[player_index] then
        History.__perPlayer[player_index] = History:new()
    end
    return History.__perPlayer[player_index]
end

---@private
---@return History
function History:new()
    local history = History:super(Object:new())
    history._pickedSlot = nil
    return history
end

---@public
---@return boolean
function History:hasPickedSlot()
    return self._pickedSlot ~= nil and self._pickedSlot:isValid()
end

---@public
---@return Slot
function History:pickedSlot()
    return self._pickedSlot
end

---@public
---@param slot Slot
function History:rememberPick(slot)
    self._pickedSlot = slot
end

---@public
function History:forgetPick()
    self._pickedSlot = nil
end
