import('lang.Object')
import('model.toolbar.section.table.Slot')
import('model.toolbar.section.table.slots.Item')
import('model.toolbar.section.table.slots.Tool')

---@class Empty : Slot
Empty = Slot:extendAs("model.toolbar.section.table.slots.Empty")

function Empty:create(parent)
    local element = Empty:createRoot(parent, {
        type = "choose-elem-button",
        elem_type = "item",
        style = "toolbar_content_sectionList_section_content_table_row_slot",
        mouse_button_filter = { "left", "middle" } })
    return Empty:new(element)
end

function Empty:new(element)
    return Empty:super(Slot:new(element))
end

function Empty:handleGuiEvent(guiEvent)
    local cursor = self:cursor()

    if guiEvent:isLeftClick() then
        if cursor:holdsSomething() then
            if cursor:holdsItem() then
                self:setItem(cursor:itemName())
            elseif cursor:holdsTool() then
                self:setTool(cursor:itemName())
            end
            self:handleItemDrag()
        end
    elseif guiEvent:isElementChange() then
        if cursor:holdsBlueprint() or cursor:holdsPlanner() then
            self:root().elem_value = nil
        elseif cursor:holdsItem() then
            self:setItem(cursor:itemName())
            self:handleItemDrag()
        elseif self:isOccupied() then
            self:setItem(self:itemName())
        end
    end
end

function Empty:itemName()
    return self:root().elem_value
end

function Empty:handleItemDrag()
    local cursor = self:cursor()
    if self:wasDragged(self:cursor():itemName()) then
        self:drag()
    end
    cursor:clear()
    self:forgetPick()
end
