import('model.toolbar.section.table.Slot')

---@private
---@class Tool : Slot
Tool = Slot:extendAs("model.toolbar.section.table.slots.Tool")

function Tool:create(parent, itemName)
    local element = Tool:createRoot(parent, {
        type = "sprite-button",
        elem_tooltip = { type = "item", name = itemName },
        sprite = "item/" .. assert(itemName),
        style = "toolbar_content_sectionList_section_content_table_row_slot",
        mouse_button_filter = { "left", "middle" } })
    return Tool:new(element)
end

function Tool:new(element)
    return Tool:super(Slot:new(element))
end

function Tool:handleGuiEvent(guiEvent)
    if guiEvent:isLeftClick() then
        self:cursor():pickTool(self:itemName())
        self:rememberPick()
    elseif guiEvent:isMiddleClick() then
        self:clear()
    end
end

function Tool:itemName()
    return self:root().elem_tooltip.name
end
